<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: melon::kernel::Kernel&lt; T, V &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('classmelon_1_1kernel_1_1_kernel.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classmelon_1_1kernel_1_1_kernel-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">melon::kernel::Kernel&lt; T, V &gt; Class Template Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div></div>
</div><!--header-->
<div class="contents">

<p>Abstract parent class for kernel implementations.  
 <a href="#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="kernel_8h_source.html">kernel.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for melon::kernel::Kernel&lt; T, V &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classmelon_1_1kernel_1_1_kernel.png" usemap="#melon::kernel::Kernel_3C_20T_2C_20V_20_3E_map" alt=""/>
  <map id="melon::kernel::Kernel_3C_20T_2C_20V_20_3E_map" name="melon::kernel::Kernel_3C_20T_2C_20V_20_3E_map">
<area href="classmelon_1_1kernel_1_1_kernel_composite_add.html" title="Composite kernel which on evaluation adds the evaluation results of its subkernels." alt="melon::kernel::KernelCompositeAdd&lt; T, V &gt;" shape="rect" coords="0,56,280,80"/>
<area href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html" title="Composite kernel which on evaluation multiplies the evaluation results of its subkernels." alt="melon::kernel::KernelCompositeMultiply&lt; T, V &gt;" shape="rect" coords="290,56,570,80"/>
<area href="classmelon_1_1kernel_1_1_kernel_constant.html" title="Kernel which always returns a constant value." alt="melon::kernel::KernelConstant&lt; T, V &gt;" shape="rect" coords="580,56,860,80"/>
<area href="classmelon_1_1kernel_1_1_stationary_kernel.html" alt="melon::kernel::StationaryKernel&lt; T, V &gt;" shape="rect" coords="870,56,1150,80"/>
<area href="classmelon_1_1kernel_1_1_kernel_r_b_f.html" title="Implementation of Radial Basis Function kernel." alt="melon::kernel::KernelRBF&lt; T, V &gt;" shape="rect" coords="725,112,1005,136"/>
<area href="classmelon_1_1kernel_1_1_matern.html" title="Abstract parent class for matern kernels." alt="melon::kernel::Matern&lt; T, V &gt;" shape="rect" coords="1015,112,1295,136"/>
<area href="classmelon_1_1kernel_1_1_matern12.html" title="Class implementation of Matern12 kernel." alt="melon::kernel::Matern12&lt; T, V &gt;" shape="rect" coords="580,168,860,192"/>
<area href="classmelon_1_1kernel_1_1_matern32.html" title="Class implementation of Matern32 kernel." alt="melon::kernel::Matern32&lt; T, V &gt;" shape="rect" coords="870,168,1150,192"/>
<area href="classmelon_1_1kernel_1_1_matern52.html" title="Class implementation of Matern52 kernel." alt="melon::kernel::Matern52&lt; T, V &gt;" shape="rect" coords="1160,168,1440,192"/>
<area href="classmelon_1_1kernel_1_1_matern_inf.html" title="Class implementation of MaternInf kernel." alt="melon::kernel::MaternInf&lt; T, V &gt;" shape="rect" coords="1450,168,1730,192"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-types" name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:afc65772b466950a64138b8914d44a0b1" id="r_afc65772b466950a64138b8914d44a0b1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">using</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#afc65772b466950a64138b8914d44a0b1">RET</a> = <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">decltype</a>(std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>&gt;() + std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt;())</td></tr>
<tr class="separator:afc65772b466950a64138b8914d44a0b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a723ab0686bbb045ff401220d51f72c2a" id="r_a723ab0686bbb045ff401220d51f72c2a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">virtual</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a723ab0686bbb045ff401220d51f72c2a">~Kernel</a> ()=<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">default</a></td></tr>
<tr class="memdesc:a723ab0686bbb045ff401220d51f72c2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <br /></td></tr>
<tr class="separator:a723ab0686bbb045ff401220d51f72c2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ec36af697437b1a9b6ff84efb237e14" id="r_a8ec36af697437b1a9b6ff84efb237e14"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">virtual</a> <a class="el" href="#afc65772b466950a64138b8914d44a0b1">RET</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a8ec36af697437b1a9b6ff84efb237e14">evaluate_kernel</a> (std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> &gt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">x1</a>, std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">x2</a>)=0</td></tr>
<tr class="memdesc:a8ec36af697437b1a9b6ff84efb237e14"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for evalualting the kernel for the points x1 and x2.  <br /></td></tr>
<tr class="separator:a8ec36af697437b1a9b6ff84efb237e14"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><div class="compoundTemplParams">template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt;<br />
class melon::kernel::Kernel&lt; T, V &gt;</div><p>Abstract parent class for kernel implementations. </p>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="afc65772b466950a64138b8914d44a0b1" name="afc65772b466950a64138b8914d44a0b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afc65772b466950a64138b8914d44a0b1">&#9670;&#160;</a></span>RET</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">using</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::RET = <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">decltype</a>(std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>&gt;() + std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt;())</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a723ab0686bbb045ff401220d51f72c2a" name="a723ab0686bbb045ff401220d51f72c2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a723ab0686bbb045ff401220d51f72c2a">&#9670;&#160;</a></span>~Kernel()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">virtual</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::~<a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a> </td>
          <td>(</td>
          <td class="paramname"><span class="paramname"></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a8ec36af697437b1a9b6ff84efb237e14" name="a8ec36af697437b1a9b6ff84efb237e14"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ec36af697437b1a9b6ff84efb237e14">&#9670;&#160;</a></span>evaluate_kernel()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">virtual</a> <a class="el" href="#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::evaluate_kernel </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>x1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>x2</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function for evalualting the kernel for the points x1 and x2. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">x1</td><td>is a vector containing the first point</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">x2</td><td>is a vector containing the second point</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the result of the kernel evaluation </dd></dl>

<p>Implemented in <a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_add.html#a2af41f4a028e420edaca18501bf10a58">melon::kernel::KernelCompositeAdd&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_multiply.html#a39cea278adc79c371f3a05cb61631ecb">melon::kernel::KernelCompositeMultiply&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_constant.html#a6bdac5c342fb8b15b5dee84d41443216">melon::kernel::KernelConstant&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">melon::kernel::Matern12&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">melon::kernel::Matern32&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">melon::kernel::Matern52&lt; T, V &gt;</a>, <a class="el" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">melon::kernel::MaternInf&lt; T, V &gt;</a>, and <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html#af77cb8a39caa7d5191aa560eb80d2f09">melon::kernel::KernelRBF&lt; T, V &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>C:/Data/Git/MeLOn/common/inc/<a class="el" href="kernel_8h_source.html">kernel.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacemelon.html">melon</a></li><li class="navelem"><a class="el" href="namespacemelon_1_1kernel.html">kernel</a></li><li class="navelem"><a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
